require_relative '_test_helper'

describe Sashite::CGN::Boolean do
  subject { Sashite::CGN::Boolean }

  let(:cgn_document) { 't' }
  let(:ruby_object) { true }

  describe '.load' do
    it 'parses a CGN string' do
      subject.load(cgn_document).must_equal ruby_object
    end

    describe 'errors' do
      it 'raises without a boolean' do
        -> { subject.load 'foobar' }.must_raise ArgumentError
      end
    end
  end

  describe '.dump' do
    it 'emits some CGN' do
      subject.dump(ruby_object).must_equal cgn_document
    end

    describe 'errors' do
      it 'raises without a boolean' do
        -> { subject.dump 'foobar' }.must_raise ArgumentError
      end
    end
  end
end
