require_relative '_test_helper'

describe Sashite::CGN::Digit do
  subject { Sashite::CGN::Digit }

  let(:cgn_document) { '8' }
  let(:ruby_object) { 8 }

  describe '.load' do
    it 'parses a CGN string' do
      subject.load(cgn_document).must_equal ruby_object
    end

    describe 'errors' do
      it 'raises with a negative integer' do
        -> { subject.load '-4' }.must_raise ArgumentError
      end
    end
  end

  describe '.dump' do
    it 'emits some CGN' do
      subject.dump(ruby_object).must_equal cgn_document
    end

    describe 'errors' do
      it 'raises with a negative integer' do
        -> { subject.dump '-4' }.must_raise ArgumentError
      end
    end
  end
end
