require_relative '_test_helper'

describe Sashite::CGN::Direction do
  subject { Sashite::CGN::Direction }

  let(:cgn_document) { '0,1,2,3,4' }
  let(:ruby_object) { [ 0, 1, 2, 3, 4 ] }

  describe '.load' do
    it 'parses a CGN string' do
      subject.load(cgn_document).must_equal ruby_object
    end

    describe 'errors' do
      it 'raises without integers' do
        -> { subject.load '4,bar' }.must_raise ArgumentError
      end
    end
  end

  describe '.dump' do
    it 'emits some CGN' do
      subject.dump(ruby_object).must_equal cgn_document
    end

    describe 'errors' do
      it 'raises without integers' do
        -> { subject.dump '4,bar' }.must_raise ArgumentError
      end
    end
  end
end
