require_relative '_test_helper'

describe Sashite::CGN::LastMovedActor do
  subject { Sashite::CGN::LastMovedActor }

  describe '.load' do
    describe 'boolean' do
      let(:cgn_document) { 't' }
      let(:ruby_object) { true }

      it 'parses a CGN string' do
        subject.load(cgn_document).must_equal ruby_object
      end

      it 'raises an error' do
        -> { subject.load 'true' }.must_raise ArgumentError
      end
    end

    describe 'null' do
      let(:cgn_document) { '_' }
      let(:ruby_object) { nil }

      it 'parses a CGN string' do
        subject.load(cgn_document).must_equal ruby_object
      end

      it 'raises an error' do
        -> { subject.load '' }.must_raise ArgumentError
      end
    end
  end

  describe '.dump' do
    describe 'boolean' do
      let(:cgn_document) { 't' }
      let(:ruby_object) { true }

      it 'emits some CGN' do
        subject.dump(ruby_object).must_equal cgn_document
      end

      it 'raises an error' do
        -> { subject.dump 'true' }.must_raise ArgumentError
      end
    end

    describe 'null' do
      let(:cgn_document) { '_' }
      let(:ruby_object) { nil }

      it 'emits some CGN' do
        subject.dump(ruby_object).must_equal cgn_document
      end

      it 'raises an error' do
        -> { subject.dump '' }.must_raise ArgumentError
      end
    end
  end
end
