require_relative '_test_helper'

describe Sashite::CGN::Name do
  subject { Sashite::CGN::Name }

  let(:cgn_document) { 'capture' }
  let(:ruby_object) { :capture }

  describe '.load' do
    it 'parses a CGN string' do
      subject.load(cgn_document).must_equal ruby_object
    end

    describe 'errors' do
      it 'raises an error' do
        -> { subject.load 'foobar' }.must_raise ArgumentError
      end
    end
  end

  describe '.dump' do
    it 'emits some CGN' do
      subject.dump(ruby_object).must_equal cgn_document
    end

    describe 'errors' do
      it 'raises an error' do
        -> { subject.dump 'foobar' }.must_raise ArgumentError
      end
    end
  end
end
