require_relative '_test_helper'

describe Sashite::CGN::Null do
  subject { Sashite::CGN::Null }

  let(:cgn_document) { '_' }
  let(:ruby_object) { nil }

  describe '.load' do
    it 'parses a CGN string' do
      subject.load(cgn_document).must_equal ruby_object
    end

    describe 'errors' do
      it 'raises without null' do
        -> { subject.load '4' }.must_raise ArgumentError
      end
    end
  end

  describe '.dump' do
    it 'emits some CGN' do
      subject.dump(ruby_object).must_equal cgn_document
    end

    describe 'errors' do
      it 'raises without null' do
        -> { subject.dump '4' }.must_raise ArgumentError
      end
    end
  end
end
