require_relative '_test_helper'

describe Sashite::CGN::Self do
  subject { Sashite::CGN::Self }

  let(:cgn_document) { 'self' }
  let(:ruby_object) { :self }

  describe '.load' do
    it 'parses a CGN string' do
      subject.load(cgn_document).must_equal ruby_object
    end

    describe 'errors' do
      it 'raises without self' do
        -> { subject.load '42' }.must_raise ArgumentError
      end
    end
  end

  describe '.dump' do
    it 'emits some CGN' do
      subject.dump(ruby_object).must_equal cgn_document
    end

    describe 'errors' do
      it 'raises without self' do
        -> { subject.dump '42' }.must_raise ArgumentError
      end
    end
  end
end
