require_relative '_test_helper'

describe Sashite::CGN::Square do
  subject { Sashite::CGN::Square }

  let(:cgn_document) { '_@an_enemy_actor+all' }
  let(:ruby_object) do
    {
      :"...attacked?" => nil,
      :"...occupied!" => :an_enemy_actor,
      :"area" => :all
    }
  end

  describe '.load' do
    it 'parses a CGN string' do
      subject.load(cgn_document).hash.must_equal ruby_object.hash
    end

    describe 'errors' do
      it 'raises witout a square' do
        -> { subject.load 'foobar' }.must_raise ArgumentError
      end
    end
  end

  describe '.dump' do
    it 'emits some CGN' do
      subject.dump(ruby_object).must_equal cgn_document
    end

    describe 'errors' do
      it 'raises witout a square' do
        -> { subject.dump 'foobar' }.must_raise ArgumentError
      end
    end
  end
end
