require_relative '_test_helper'

describe Sashite::CGN::State do
  subject { Sashite::CGN::State }

  let(:cgn_document) { 't&_' }
  let(:ruby_object) do
    {
      :"...last_moved_actor?" => true,
      :"...previous_moves_counter" => nil
    }
  end

  describe '.load' do
    it 'parses a CGN string' do
      subject.load(cgn_document).hash.must_equal ruby_object.hash
    end

    describe 'errors' do
      it 'raises without a state' do
        -> { subject.load 'foobar' }.must_raise ArgumentError
      end
    end
  end

  describe '.dump' do
    it 'emits some CGN' do
      subject.dump(ruby_object).must_equal cgn_document
    end

    describe 'errors' do
      it 'raises without a state' do
        -> { subject.dump 'foobar' }.must_raise ArgumentError
      end
    end
  end
end
