require_relative '_test_helper'

describe Sashite::CGN::Subject do
  subject { Sashite::CGN::Subject }

  let(:cgn_document) { 't<self>_&_' }
  let(:ruby_object) do
    {
      :"...ally?" => true,
      :"actor" => :self,
      :"state" => {
        :"...last_moved_actor?" => nil,
        :"...previous_moves_counter" => nil
      }
    }
  end

  describe '.load' do
    it 'parses a CGN string' do
      subject.load(cgn_document).hash.must_equal ruby_object.hash
    end

    describe 'errors' do
      it 'raises without a subject' do
        -> { subject.load 'foobar' }.must_raise ArgumentError
      end
    end
  end

  describe '.dump' do
    it 'emits some CGN' do
      subject.dump(ruby_object).must_equal cgn_document
    end

    describe 'errors' do
      it 'raises without a subject' do
        -> { subject.dump 'foobar' }.must_raise ArgumentError
      end
    end
  end
end
