require_relative '_test_helper'

describe Sashite::CGN::UnsignedIntegerExcludingZero do
  subject { Sashite::CGN::UnsignedIntegerExcludingZero }

  let(:cgn_document) { '42' }
  let(:ruby_object) { 42 }

  describe '.load' do
    it 'parses a CGN string' do
      subject.load(cgn_document).must_equal ruby_object
    end

    describe 'errors' do
      it 'raises with a negative integer' do
        -> { subject.load '-42' }.must_raise ArgumentError
      end

      it 'raises with a zero' do
        -> { subject.load '0' }.must_raise ArgumentError
      end
    end
  end

  describe '.dump' do
    it 'emits some CGN' do
      subject.dump(ruby_object).must_equal cgn_document
    end

    describe 'errors' do
      it 'raises with a negative integer' do
        -> { subject.dump '-42' }.must_raise ArgumentError
      end

      it 'raises with a zero' do
        -> { subject.dump '0' }.must_raise ArgumentError
      end
    end
  end
end
