require_relative '_test_helper'

describe Sashite::CGN::Verb do
  subject { Sashite::CGN::Verb }

  let(:cgn_document) { 'shift[4,2]42' }
  let(:ruby_object) do
    {
      name: :shift,
      vector: {
        direction: [4,2],
        :"...maximum_magnitude" => 42
      }
    }
  end

  describe '.load' do
    it 'parses a CGN string' do
      subject.load(cgn_document).hash.must_equal ruby_object.hash
    end

    describe 'errors' do
      it 'raises without a verb structure' do
        -> { subject.load 'foobar' }.must_raise ArgumentError
      end
    end
  end

  describe '.dump' do
    it 'emits some CGN' do
      subject.dump(ruby_object).must_equal cgn_document
    end

    describe 'errors' do
      it 'raises without a verb structure' do
        -> { subject.dump 'foobar' }.must_raise ArgumentError
      end
    end
  end
end
